#!/bin/csh -f
# dd_multi
# Copyright 2001 Bob Toxen.  All rights reserved.
# The author may be reached at book@cavu.com
# May be distributed under the GNU public license
#
set email=joe@pentacorp.com
set flag=/home/joe/dd_m
set blksiz=100k
set blocks=10000
# Reads stdin, copies 1 GB to tape, sends email to
# to SysAdmin, waits for him to do
#   "touch $flag" for next tape
#   "echo done>$flag" if count was less than
#     10000, indicating last tape.
loop:
	dd ibs=$blksiz obs=$blksiz count=$blocks of=/dev/rmt0 \
	  |& Mail -s "change tape, touch $flag" \
	  $email
loop2:
	if ( -f $flag ) then
		if ( -s $flag ) then
			/bin/rm $flag
			echo backup done | Mail -s "dd done" \
			  $email
			exit 0
		endif
		/bin/rm $flag
		goto loop
	endif
	sleep 30
	goto loop2
