#!/bin/csh -f

# Detect and copy running executables deleted from disk.
# DANGER: this program must run as root to capture all
# data but if it finds something root *may* be compromised.
# Optionally kills the program.
# Requires kernel 2.2 or newer.
#
# Copyright 2001 Bob Toxen.  All rights reserved.
# This program may be used under the terms of the
# GNU GENERAL PUBLIC LICENSE Version 2.
#
# Offered as is with no warranty of any kind.

set savdir=/home/samspade/delexe_dir
set emailaddr=samspade@pentacorp.com
set g='(deleted)'
set s='s,/proc/\([0-9][0-9]*\).*,\1,'
set p=(`file /proc/[0-9]*/exe|grep "$g"|sed "$s"`)
umask 077
foreach i ( $p )
  if ( ! -f $savdir/$i ) then
	echo /bin/dd if=/proc/$i/exe of=$savdir/$i
	echo /bin/dd if=/proc/$i/exe of=$savdir/$i | \
	  /bin/mail -s 'Del EXE' $emailaddr
	/bin/dd if=/proc/$i/exe of=$savdir/$i >&! /dev/null
	/bin/ls -l /proc/$i/exe >&! $savdir/$i.ls
# Uncomment next line to kill it automatically
#	/bin/kill -9 $i
  else
	echo already captured /proc/$i/exe
  endif
end
